

#define RangeResult(x , low, high) (__max(low, __min(x, high)))

const unsigned int MaxMediaTypeCount = 1;
const unsigned int MaxThreadNumber= 5;
const unsigned int MaxPossibleResponseFromSingleConnection=100;//is it possible?
const unsigned int MaxRequestPoolSize=10;
const unsigned int DefaultRequestBufferSize=1024*2;

const unsigned int DefaultDataChunkCapacity = 1024*64;


extern void* selectPictureByIndex(int id, char*& ptr, int& length);
extern void* selectMediaDataByIndex(int mediaType, int id, char*& ptr, int& length);


extern void freeResult(void* res);

static const char* TextFormat = "text/html; charset=utf-8";

static const TCHAR* textHeader=
_T("<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Transitional//CN\" \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd\">\
<html>\
    <head>\
	<meta name=\"keywords\" content=\"million asian pretty women pictures\" >\
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\
        <title>You can upload a new picture without size limit!</title>\
		<script>\
function viewmypic(mypic,imgfile) {\
if (imgfile.value){\
mypic.src=imgfile.value;\
mypic.style.display=\"\";\
mypic.border=1; mypic.width=300;mypic.height=300;\
}}\
</script>\
    </head>\
    <body>");


static const TCHAR* textBegin=
_T("<p>All pictures are collected by myself in internet with help of my little program \
		<a href=http://www.staroceans.net/HttpClient-2.0.zip> spider</a> This is really, really a primitive one \
		and I keep debugging and improving it.</p>");



static const TCHAR* textEnd=
_T("<p>The quantity of this database is increasing daily. Currently there are over 100k pictures.\
		The pictures are all resized to fit screen size by my little tool \
<a href=http://www.staroceans.net/MySqlTools-stable.zip>mysqltools</a>.</p>\
   <p><a  href=\"http://www.staroceans.net/HttpServer-stable-UTF8.zip\"> The source code of server is here</a> </p>\
   </form>\
    </body>\
</html>");


const int MediaBatchNumber = 12;

const int CacheTableSize = MediaBatchNumber * 1;

struct MyHashTable
{
	int mediaType;	
	MyHashTable();
	int hash(int index);   
	int cacheTable[CacheTableSize];
	int sizeTable[CacheTableSize];
	void* sqlResTable[CacheTableSize];
	char* addressTable[CacheTableSize];
};


struct HttpServerWorker
{
	static int minMediaId[MaxMediaTypeCount];
	static int maxMediaId[MaxMediaTypeCount];
	static int maxMediaPage[MaxMediaTypeCount];	  
	static LPBYTE hideImagePtr;
	static DWORD  hideImageSize;

	MySqlHelper mySqlHelper;
  	
	MyHashTable myMediaHashTable[MaxMediaTypeCount];
	MyHashTable myThumbHashTable[MaxMediaTypeCount];

	MYSQL mysql;
	bool isConnected;
	static HANDLE	hReqQueue;
	static bool canStop;
 
	FILE* stream;
	int currentMediaId[MaxMediaTypeCount];
	int currentMediaPage[MaxMediaTypeCount];

	char myDatabaseIP[32];

	HANDLE threadHandle;
	HANDLE semaphore;
	int threadId;
	
	bool isAssigned;
	HTTP_CONNECTION_ID connectionId;
	//CRITICAL_SECTION  cs;	
	PHTTP_REQUEST requestBuffer; 
	int requestBufferSize;
	
	TCHAR htmlBuffer[4096];

	HttpServerWorker();
	bool init(LPSTR dbAddress);
	void uninit();
	bool recoverFromDB();
	int hash(MyHashTable& hashTable, int id, bool isThumb);

	
	void createEntryPage(HTTP_DATA_CHUNK& dataChunk);
	void createPage(int mediaType, HTTP_DATA_CHUNK& dataChunk, bool refresh=false);
	bool getMediaData(int mediaType, HTTP_DATA_CHUNK& dataChunk, bool isThumb);
	void errHandle(const _TCHAR* reason);
	void* selectMediaDataByIndex(int mediaType, int id, char*& ptr, int& length, bool isThumb);
	void* selectPictureByIndex(int id, char*& ptr, int& length);
	void addSignature(_TCHAR* picture_name);
	int selectBatchPicture(int idStart, int number, char*results[], int lengths[]);
 
	bool doSendHttpResponse(int mediaType, HTTP_RESPONSE& response, 
									 HTTP_DATA_CHUNK& dataChunk, const WCHAR* action);
	bool sendHttpResponse();
	void analysis(int mediaType);
	bool doSendQuery(int mediaType, HTTP_RESPONSE& response, HTTP_DATA_CHUNK& dataChunk, 
		PCWSTR action);
	bool increaseInt(int id, int data, char* field, char* table);
	bool decreaseInt(int id, unsigned int data, char* field, char* table);
	bool checkHideCounter(int& counter, int mediaType, int id);

	int doRecvFile();
	bool updateMediaDataRange(int mediaType);

	bool selectNumberData(int& data, int id, char* field, char* table);
	bool sendHttpResponseHelper(int mediaType, HTTP_RESPONSE& response);
	bool showUploadedMediaData(int mediaType, int repeatId = 0);

};


struct MyHttpServer
{
	WCHAR url[256];
	TCHAR	htmlBuffer[4096];
	HANDLE	hReqQueue;
	HttpServerWorker workers[MaxThreadNumber];
	bool init(TCHAR* url, LPSTR dbIP);
	static FILE* log;

	MyHttpServer();
	DWORD work();
	void notifyWorker(PHTTP_REQUEST request);
	int retrieveWorker(PHTTP_REQUEST& request);
	void notifyMaxConnection(PHTTP_REQUEST request);

	void handlePost(PHTTP_REQUEST pReq);

	
	void waitForAllThreadIdle();

	static bool initMediaDataRange(MYSQL* mysql, int mediaType, int& minId, 
		int& maxId, int& count);
	//void quit(int index);

	void uninit();
};



